Package org.springframework.jmx.access

# Class NotificationListenerRegistrar

java.lang.Object
org.springframework.jmx.support.NotificationListenerHolder
org.springframework.jmx.access.NotificationListenerRegistrar

All Implemented Interfaces:
  `org.springframework.beans.factory.DisposableBean`, `org.springframework.beans.factory.InitializingBean`

public class NotificationListenerRegistrar extends NotificationListenerHolder implements org.springframework.beans.factory.InitializingBean, org.springframework.beans.factory.DisposableBean
Registrar object that associates a specific `NotificationListener` with one or more MBeans in an `MBeanServer` (typically via a `MBeanServerConnection`).

Since:
  2.5.2
Author:
  Juergen Hoeller
See Also:
  - `setServer(javax.management.MBeanServerConnection)`
  - `NotificationListenerHolder.setMappedObjectNames(java.lang.Object...)`
  - `NotificationListenerHolder.setNotificationListener(javax.management.NotificationListener)`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final org.apache.commons.logging.Log`
`logger`
Logger available to subclasses.

### Fields inherited from class org.springframework.jmx.support.NotificationListenerHolder

`mappedObjectNames`

## Constructor Summary

Constructors
Constructor
Description
`NotificationListenerRegistrar()`

## Method Summary

Modifier and Type
Method
Description
`void`
`afterPropertiesSet()`
`void`
`destroy()`
Unregisters the specified `NotificationListener`.
`Map<String,?>`
`getEnvironment()`
Allow `Map` access to the environment to be set for the connector, with the option to add or override specific entries.
`void`
`prepare()`
Registers the specified `NotificationListener`.
`void`
`setAgentId(String agentId)`
Set the agent id of the `MBeanServer` to locate.
`void`
`setEnvironment(Map<String,?> environment)`
Specify the environment for the JMX connector.
`void`
`setServer(MBeanServerConnection server)`
Set the `MBeanServerConnection` used to connect to the MBean which all invocations are routed to.
`void`
`setServiceUrl(String url)`
Set the service URL of the remote `MBeanServer`.

### Methods inherited from class org.springframework.jmx.support.NotificationListenerHolder

`equals, getHandback, getNotificationFilter, getNotificationListener, getResolvedObjectNames, hashCode, setHandback, setMappedObjectName, setMappedObjectNames, setNotificationFilter, setNotificationListener`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### logger

protected final org.apache.commons.logging.Log logger
Logger available to subclasses.

## Constructor Details

### NotificationListenerRegistrar

public NotificationListenerRegistrar()

## Method Details

### setServer

public void setServer(MBeanServerConnection server)
Set the `MBeanServerConnection` used to connect to the MBean which all invocations are routed to.

### setEnvironment

public void setEnvironment(@Nullable Map<String,?> environment)
Specify the environment for the JMX connector.

See Also:
  - `JMXConnectorFactory.connect(javax.management.remote.JMXServiceURL, java.util.Map)`

### getEnvironment

@Nullable public Map<String,?> getEnvironment()
Allow `Map` access to the environment to be set for the connector, with the option to add or override specific entries.

Useful for specifying entries directly, for example via `environment[myKey]`. This is particularly useful for adding or overriding entries in child bean definitions.

### setServiceUrl

public void setServiceUrl(String url) throws MalformedURLException
Set the service URL of the remote `MBeanServer`.

Throws:
  `MalformedURLException`

### setAgentId

public void setAgentId(String agentId)
Set the agent id of the `MBeanServer` to locate.

Default is none. If specified, this will result in an attempt being made to locate the attendant MBeanServer, unless the `"serviceUrl"` property has been set.

See Also:
  - `

    Specifying the empty String indicates the platform MBeanServer.

    `

### afterPropertiesSet

public void afterPropertiesSet()

Specified by:
  `afterPropertiesSet` in interface `org.springframework.beans.factory.InitializingBean`

### prepare

public void prepare()
Registers the specified `NotificationListener`.

Ensures that an `MBeanServerConnection` is configured and attempts to detect a local connection if one is not supplied.

### destroy

public void destroy()
Unregisters the specified `NotificationListener`.

Specified by:
  `destroy` in interface `org.springframework.beans.factory.DisposableBean`